----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY test2_top is
port (
	clk : in  std_logic;
	rst : in  std_logic;
	lat_en : in  std_logic;
	in_bit : in  std_logic;
	in_bus : in std_logic_vector(3 downto 0);
	out_bit : out  std_logic;
	out_bus : out std_logic_vector(3 downto 0);
	mux_en : in  std_logic;
	mux_ctrl : in std_logic_vector(1 downto 0);
	muxin0_bit : in  std_logic;
	muxin1_bit : in  std_logic;
	muxin2_bit : in  std_logic;
	muxin3_bit : in  std_logic;
	muxin_bus0 : in std_logic_vector(7 downto 0);
	muxin_bus1 : in std_logic_vector(7 downto 0);
	muxin_bus2 : in std_logic_vector(7 downto 0);
	muxin_bus3 : in std_logic_vector(7 downto 0);
	muxout_bit : out  std_logic;
	muxout_bus : out std_logic_vector(7 downto 0)
);
end test2_top;

architecture RTL of test2_top is
begin
	
	one_bit_lat : LATCH port map (
		RST => rst,
		EN => lat_en,
		CLK => clk,
		LAT_IN => in_bit,
		LAT_OUT => out_bit 
	);
	
	four_bit_lat : LATCH_n_bit
 	generic map(num_bits => 4)
 	port map (
		RST => rst,
		EN => lat_en,
		CLK => clk,
		LAT_IN => in_bus,
		LAT_OUT => out_bus 
	);
	
	one_bit_mux : MUX port map (
		MUX_OUT => muxout_bit,
		EN => mux_en,
		OUT_SEL => mux_ctrl,
		MUX_IN0 => muxin0_bit,
		MUX_IN1 => muxin1_bit,
		MUX_IN2 => muxin2_bit,
		MUX_IN3 => muxin3_bit
	);
	
	four_bit_mux : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => muxout_bus,
		EN => mux_en,
		OUT_SEL => mux_ctrl,
		MUX_IN0 => muxin_bus0,
		MUX_IN1 => muxin_bus1,
		MUX_IN2 => muxin_bus2,
		MUX_IN3 => muxin_bus3
	);
end RTL;


