----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY test2_top_tb is

end ENTITY test2_top_tb;

ARCHITECTURE behavioral of test2_top_tb is

COMPONENT test2_top is
port (
	clk : in  std_logic;
	rst : in  std_logic;
	lat_en : in  std_logic;
	in_bit : in  std_logic;
	in_bus : in std_logic_vector(3 downto 0);
	out_bit : out  std_logic;
	out_bus : out std_logic_vector(3 downto 0);
	mux_en : in  std_logic;
	mux_ctrl : in std_logic_vector(1 downto 0);
	muxin0_bit : in  std_logic;
	muxin1_bit : in  std_logic;
	muxin2_bit : in  std_logic;
	muxin3_bit : in  std_logic;
	muxin_bus0 : in std_logic_vector(7 downto 0);
	muxin_bus1 : in std_logic_vector(7 downto 0);
	muxin_bus2 : in std_logic_vector(7 downto 0);
	muxin_bus3 : in std_logic_vector(7 downto 0);
	muxout_bit : out  std_logic;
	muxout_bus : out std_logic_vector(7 downto 0)
);
end COMPONENT;

	signal clk :  std_logic;
	signal rst :  std_logic;
	signal lat_en :  std_logic;
	signal in_bit :  std_logic;
	signal in_bus : std_logic_vector(3 downto 0);
	signal out_bit :  std_logic;
	signal out_bus : std_logic_vector(3 downto 0);
	signal mux_en :  std_logic;
	signal mux_ctrl : std_logic_vector(1 downto 0);
	signal muxin0_bit :  std_logic;
	signal muxin1_bit :  std_logic;
	signal muxin2_bit :  std_logic;
	signal muxin3_bit :  std_logic;
	signal muxin_bus0 : std_logic_vector(7 downto 0);
	signal muxin_bus1 : std_logic_vector(7 downto 0);
	signal muxin_bus2 : std_logic_vector(7 downto 0);
	signal muxin_bus3 : std_logic_vector(7 downto 0);
	signal muxout_bit :  std_logic;
	signal muxout_bus : std_logic_vector(7 downto 0);
	
	signal sim_done : boolean := false;

begin

inst_test2_top : test2_top
	port map(
		clk => clk,
		rst => rst,
		lat_en => lat_en,
		in_bit => in_bit,
		in_bus => in_bus,
		out_bit => out_bit,
		out_bus => out_bus,
		mux_en => mux_en,
		mux_ctrl => mux_ctrl,
		muxin0_bit => muxin0_bit,
		muxin1_bit => muxin1_bit,
		muxin2_bit => muxin2_bit,
		muxin3_bit => muxin3_bit,
		muxin_bus0 => muxin_bus0,
		muxin_bus1 => muxin_bus1,
		muxin_bus2 => muxin_bus2,
		muxin_bus3 => muxin_bus3,
		muxout_bit => muxout_bit,
		muxout_bus => muxout_bus
	);

clk_proc : process 
	begin
		if (not sim_done) then
			clk <= '0';
			wait for 20 ns;
			clk <= '1';
			wait for 20 ns;
		else
			report "sim_done";
			wait; --wait forever
		end if;
	end process clk_proc;

latch_test : process
	begin
		lat_en <= '0';
		in_bit <= '0';
		in_bus <= "0000";
		wait for 10 ns;
		
		in_bit <= '1';
		in_bus <= "0101";
		wait for 10 ns;
		
		lat_en <= '1';
		wait for 50 ns;
		
		in_bit <= '0';
		in_bus <= "1010";
		wait for 50 ns;
		
		lat_en <= '0';
		wait;
	end process;
	
mux_test : process
	begin
		mux_en <= '0';
		mux_ctrl <= "00";
		muxin0_bit <= '0';
		muxin1_bit <= '1';
		muxin2_bit <= '0';
		muxin3_bit <= '1';
		muxin_bus0 <= x"00";
		muxin_bus1 <= x"FF";
		muxin_bus2 <= x"5A";
		muxin_bus3 <= x"A5";
		wait for 10 ns;
		
		mux_en <= '1';
		wait for 20 ns;
				
		wait for 20 ns;
		mux_ctrl <= "01";
		wait for 20 ns;
		mux_ctrl <= "10";
		wait for 20 ns;
		mux_ctrl <= "11";
		wait for 20 ns;
		mux_en <= '0';
		
		wait;
	end process;

sim_time : process
	begin
		rst <= '1';
		wait for 10 ns;
		rst <= '0';
		wait for 150 ns;
		sim_done <= true;
		wait;
	end process;
	
end;

