----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;


ENTITY test5_top_tb is

end ENTITY test5_top_tb;

ARCHITECTURE behavioral of test5_top_tb is

procedure Rd_Access_Ctrl (
		signal cs_n		: 	out		std_logic;
		signal read_n 	: 	out		std_logic;
		signal write_n 	: 	out		std_logic;
		signal reg_addr	:	in		std_logic_vector(7 downto 0);
		signal addr_out	: 	out		std_logic_vector(7 downto 0)
) is
		
begin
	cs_n <= '1';
	read_n <= '1';
	write_n <= '1';
	wait for 30 ns;
		
	addr_out <= reg_addr;
	wait for 5 ns;
	cs_n <= '0';
	wait for 5 ns;
	read_n <= '0';		-- read access 
	wait for 60 ns;
	read_n <= '1';
	wait for 5 ns;
	cs_n <= '1';
	wait for 20 ns;
end procedure;

procedure Wr_Access_Ctrl (
		signal cs_n		: 	out		std_logic;
		signal read_n 	: 	out		std_logic;
		signal write_n 	: 	out		std_logic;
		signal reg_addr	:	in		std_logic_vector(7 downto 0);
		signal addr_out	: 	out		std_logic_vector(7 downto 0)
) is
		
begin
	cs_n <= '1';
	read_n <= '1';
	write_n <= '1';
	wait for 30 ns;
		
	addr_out <= reg_addr;
	wait for 5 ns;
	cs_n <= '0';
	wait for 5 ns;
	write_n <= '0';		-- read access 
	wait for 60 ns;
	write_n <= '1';
	wait for 5 ns;
	cs_n <= '1';
	wait for 20 ns;
end procedure;

COMPONENT test5_top is
port (
	rst : in  std_logic;
	csn : in  std_logic;
	oen : in  std_logic;
	wrn : in  std_logic;
	addr : in std_logic_vector(7 downto 0);
	rd_str : out std_logic_vector(3 downto 0);
	wr_str : out std_logic_vector(3 downto 0)
);
end COMPONENT;

	signal rst :  std_logic;
	signal csn :  std_logic;
	signal oen :  std_logic;
	signal wrn :  std_logic;
	signal addr : std_logic_vector(7 downto 0);
	signal rd_str : std_logic_vector(3 downto 0);
	signal wr_str : std_logic_vector(3 downto 0);
	signal sim_done : boolean := false;
	signal r_addr	: std_logic_vector(7 downto 0);
	
begin

inst_test5_top : test5_top
	port map(
		rst => rst,
		csn => csn,
		oen => oen,
		wrn => wrn,
		addr => addr,
		rd_str => rd_str,
		wr_str => wr_str
	);

strb_proc : process
	begin
		r_addr <= x"00"; Rd_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- read access to reg at addr 0
		r_addr <= x"01"; Rd_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- read access to reg at addr 1
		r_addr <= x"02"; Rd_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- read access to reg at addr 2
		r_addr <= x"03"; Rd_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- read access to reg at addr 3

		r_addr <= x"00"; Wr_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- write access to reg at addr 0
		r_addr <= x"01"; Wr_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- write access to reg at addr 1
		r_addr <= x"02"; Wr_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- write access to reg at addr 2
		r_addr <= x"03"; Wr_Access_Ctrl(csn, oen, wrn, r_addr, addr);	-- write access to reg at addr 3
		wait;
	end process;
	
sim_time : process
	begin
		rst <= '1';
		wait for 10 ns;
		rst <= '0';
		wait for 1100 ns;
		sim_done <= true;
		wait;
	end process;	

end;

